/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from linux-dmabuf-unstable-v1.xml by mir_wayland_generator
 */

#include "linux-dmabuf-unstable-v1_wrapper.h"

#include <boost/exception/diagnostic_information.hpp>
#include <wayland-server-core.h>

#include "mir/log.h"
#include "mir/wayland/protocol_error.h"
#include "mir/wayland/client.h"

namespace mir
{
namespace wayland
{
extern struct wl_interface const wl_buffer_interface_data;
extern struct wl_interface const zwp_linux_buffer_params_v1_interface_data;
extern struct wl_interface const zwp_linux_dmabuf_v1_interface_data;
}
}

namespace mw = mir::wayland;

namespace
{
struct wl_interface const* all_null_types [] {
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr};
}

// LinuxDmabufV1

struct mw::LinuxDmabufV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "LinuxDmabufV1::destroy()");
        }
    }

    static void create_params_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t params_id)
    {
        wl_resource* params_id_resolved{
            wl_resource_create(client, &zwp_linux_buffer_params_v1_interface_data, wl_resource_get_version(resource), params_id)};
        if (params_id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<LinuxDmabufV1*>(wl_resource_get_user_data(resource));
            me->create_params(params_id_resolved);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "LinuxDmabufV1::create_params()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<LinuxDmabufV1*>(wl_resource_get_user_data(resource));
    }

    static void bind_thunk(struct wl_client* client, void* data, uint32_t version, uint32_t id)
    {
        auto me = static_cast<LinuxDmabufV1::Global*>(data);
        auto resource = wl_resource_create(
            client,
            &zwp_linux_dmabuf_v1_interface_data,
            std::min((int)version, Thunks::supported_version),
            id);
        if (resource == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            me->bind(resource);
        }
        catch(...)
        {
            internal_error_processing_request(client, "LinuxDmabufV1 global bind");
        }
    }

    static struct wl_interface const* create_params_types[];
    static struct wl_message const request_messages[];
    static struct wl_message const event_messages[];
    static void const* request_vtable[];
};

int const mw::LinuxDmabufV1::Thunks::supported_version = 3;

mw::LinuxDmabufV1::LinuxDmabufV1(struct wl_resource* resource, Version<3>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::LinuxDmabufV1::~LinuxDmabufV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

void mw::LinuxDmabufV1::send_format_event(uint32_t format) const
{
    wl_resource_post_event(resource, Opcode::format, format);
}

bool mw::LinuxDmabufV1::version_supports_modifier()
{
    return wl_resource_get_version(resource) >= 3;
}

void mw::LinuxDmabufV1::send_modifier_event_if_supported(uint32_t format, uint32_t modifier_hi, uint32_t modifier_lo) const
{
    if (wl_resource_get_version(resource) >= 3)
    {
        wl_resource_post_event(resource, Opcode::modifier, format, modifier_hi, modifier_lo);
    }
}

void mw::LinuxDmabufV1::send_modifier_event(uint32_t format, uint32_t modifier_hi, uint32_t modifier_lo) const
{
    if (wl_resource_get_version(resource) >= 3)
    {
        wl_resource_post_event(resource, Opcode::modifier, format, modifier_hi, modifier_lo);
    }
    else
    {
        tried_to_send_unsupported_event(client->raw_client(), resource, "modifier", 3);
    }
}

bool mw::LinuxDmabufV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwp_linux_dmabuf_v1_interface_data, Thunks::request_vtable);
}

mw::LinuxDmabufV1::Global::Global(wl_display* display, Version<3>)
    : wayland::Global{
          wl_global_create(
              display,
              &zwp_linux_dmabuf_v1_interface_data,
              Thunks::supported_version,
              this,
              &Thunks::bind_thunk)}
{
}

auto mw::LinuxDmabufV1::Global::interface_name() const -> char const*
{
    return LinuxDmabufV1::interface_name;
}

struct wl_interface const* mw::LinuxDmabufV1::Thunks::create_params_types[] {
    &zwp_linux_buffer_params_v1_interface_data};

struct wl_message const mw::LinuxDmabufV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types},
    {"create_params", "n", create_params_types}};

struct wl_message const mw::LinuxDmabufV1::Thunks::event_messages[] {
    {"format", "u", all_null_types},
    {"modifier", "3uuu", all_null_types}};

void const* mw::LinuxDmabufV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk,
    (void*)Thunks::create_params_thunk};

mw::LinuxDmabufV1* mw::LinuxDmabufV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwp_linux_dmabuf_v1_interface_data, LinuxDmabufV1::Thunks::request_vtable))
    {
        return static_cast<LinuxDmabufV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// LinuxBufferParamsV1

struct mw::LinuxBufferParamsV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "LinuxBufferParamsV1::destroy()");
        }
    }

    static void add_thunk(struct wl_client* client, struct wl_resource* resource, int32_t fd, uint32_t plane_idx, uint32_t offset, uint32_t stride, uint32_t modifier_hi, uint32_t modifier_lo)
    {
        mir::Fd fd_resolved{fd};
        try
        {
            auto me = static_cast<LinuxBufferParamsV1*>(wl_resource_get_user_data(resource));
            me->add(fd_resolved, plane_idx, offset, stride, modifier_hi, modifier_lo);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "LinuxBufferParamsV1::add()");
        }
    }

    static void create_thunk(struct wl_client* client, struct wl_resource* resource, int32_t width, int32_t height, uint32_t format, uint32_t flags)
    {
        try
        {
            auto me = static_cast<LinuxBufferParamsV1*>(wl_resource_get_user_data(resource));
            me->create(width, height, format, flags);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "LinuxBufferParamsV1::create()");
        }
    }

    static void create_immed_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t buffer_id, int32_t width, int32_t height, uint32_t format, uint32_t flags)
    {
        wl_resource* buffer_id_resolved{
            wl_resource_create(client, &wl_buffer_interface_data, wl_resource_get_version(resource), buffer_id)};
        if (buffer_id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<LinuxBufferParamsV1*>(wl_resource_get_user_data(resource));
            me->create_immed(buffer_id_resolved, width, height, format, flags);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "LinuxBufferParamsV1::create_immed()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<LinuxBufferParamsV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_interface const* create_immed_types[];
    static struct wl_interface const* created_types[];
    static struct wl_message const request_messages[];
    static struct wl_message const event_messages[];
    static void const* request_vtable[];
};

int const mw::LinuxBufferParamsV1::Thunks::supported_version = 3;

mw::LinuxBufferParamsV1::LinuxBufferParamsV1(struct wl_resource* resource, Version<3>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::LinuxBufferParamsV1::~LinuxBufferParamsV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

void mw::LinuxBufferParamsV1::send_created_event(struct wl_resource* buffer) const
{
    wl_resource_post_event(resource, Opcode::created, buffer);
}

void mw::LinuxBufferParamsV1::send_failed_event() const
{
    wl_resource_post_event(resource, Opcode::failed);
}

bool mw::LinuxBufferParamsV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwp_linux_buffer_params_v1_interface_data, Thunks::request_vtable);
}

uint32_t const mw::LinuxBufferParamsV1::Error::already_used;
uint32_t const mw::LinuxBufferParamsV1::Error::plane_idx;
uint32_t const mw::LinuxBufferParamsV1::Error::plane_set;
uint32_t const mw::LinuxBufferParamsV1::Error::incomplete;
uint32_t const mw::LinuxBufferParamsV1::Error::invalid_format;
uint32_t const mw::LinuxBufferParamsV1::Error::invalid_dimensions;
uint32_t const mw::LinuxBufferParamsV1::Error::out_of_bounds;
uint32_t const mw::LinuxBufferParamsV1::Error::invalid_wl_buffer;
uint32_t const mw::LinuxBufferParamsV1::Flags::y_invert;
uint32_t const mw::LinuxBufferParamsV1::Flags::interlaced;
uint32_t const mw::LinuxBufferParamsV1::Flags::bottom_first;

struct wl_interface const* mw::LinuxBufferParamsV1::Thunks::create_immed_types[] {
    &wl_buffer_interface_data,
    nullptr,
    nullptr,
    nullptr,
    nullptr};

struct wl_interface const* mw::LinuxBufferParamsV1::Thunks::created_types[] {
    &wl_buffer_interface_data};

struct wl_message const mw::LinuxBufferParamsV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types},
    {"add", "huuuuu", all_null_types},
    {"create", "iiuu", all_null_types},
    {"create_immed", "2niiuu", create_immed_types}};

struct wl_message const mw::LinuxBufferParamsV1::Thunks::event_messages[] {
    {"created", "n", created_types},
    {"failed", "", all_null_types}};

void const* mw::LinuxBufferParamsV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk,
    (void*)Thunks::add_thunk,
    (void*)Thunks::create_thunk,
    (void*)Thunks::create_immed_thunk};

mw::LinuxBufferParamsV1* mw::LinuxBufferParamsV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwp_linux_buffer_params_v1_interface_data, LinuxBufferParamsV1::Thunks::request_vtable))
    {
        return static_cast<LinuxBufferParamsV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

namespace mir
{
namespace wayland
{

struct wl_interface const zwp_linux_dmabuf_v1_interface_data {
    mw::LinuxDmabufV1::interface_name,
    mw::LinuxDmabufV1::Thunks::supported_version,
    2, mw::LinuxDmabufV1::Thunks::request_messages,
    2, mw::LinuxDmabufV1::Thunks::event_messages};

struct wl_interface const zwp_linux_buffer_params_v1_interface_data {
    mw::LinuxBufferParamsV1::interface_name,
    mw::LinuxBufferParamsV1::Thunks::supported_version,
    4, mw::LinuxBufferParamsV1::Thunks::request_messages,
    2, mw::LinuxBufferParamsV1::Thunks::event_messages};

}
}
