/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from ext-session-lock-v1.xml by mir_wayland_generator
 */

#include "ext-session-lock-v1_wrapper.h"

#include <boost/exception/diagnostic_information.hpp>
#include <wayland-server-core.h>

#include "mir/log.h"
#include "mir/wayland/protocol_error.h"
#include "mir/wayland/client.h"

namespace mir
{
namespace wayland
{
extern struct wl_interface const ext_session_lock_manager_v1_interface_data;
extern struct wl_interface const ext_session_lock_surface_v1_interface_data;
extern struct wl_interface const ext_session_lock_v1_interface_data;
extern struct wl_interface const wl_output_interface_data;
extern struct wl_interface const wl_surface_interface_data;
}
}

namespace mw = mir::wayland;

namespace
{
struct wl_interface const* all_null_types [] {
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr};
}

// SessionLockManagerV1

struct mw::SessionLockManagerV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "SessionLockManagerV1::destroy()");
        }
    }

    static void lock_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &ext_session_lock_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<SessionLockManagerV1*>(wl_resource_get_user_data(resource));
            me->lock(id_resolved);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "SessionLockManagerV1::lock()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<SessionLockManagerV1*>(wl_resource_get_user_data(resource));
    }

    static void bind_thunk(struct wl_client* client, void* data, uint32_t version, uint32_t id)
    {
        auto me = static_cast<SessionLockManagerV1::Global*>(data);
        auto resource = wl_resource_create(
            client,
            &ext_session_lock_manager_v1_interface_data,
            std::min((int)version, Thunks::supported_version),
            id);
        if (resource == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            me->bind(resource);
        }
        catch(...)
        {
            internal_error_processing_request(client, "SessionLockManagerV1 global bind");
        }
    }

    static struct wl_interface const* lock_types[];
    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::SessionLockManagerV1::Thunks::supported_version = 1;

mw::SessionLockManagerV1::SessionLockManagerV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::SessionLockManagerV1::~SessionLockManagerV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::SessionLockManagerV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &ext_session_lock_manager_v1_interface_data, Thunks::request_vtable);
}

mw::SessionLockManagerV1::Global::Global(wl_display* display, Version<1>)
    : wayland::Global{
          wl_global_create(
              display,
              &ext_session_lock_manager_v1_interface_data,
              Thunks::supported_version,
              this,
              &Thunks::bind_thunk)}
{
}

auto mw::SessionLockManagerV1::Global::interface_name() const -> char const*
{
    return SessionLockManagerV1::interface_name;
}

struct wl_interface const* mw::SessionLockManagerV1::Thunks::lock_types[] {
    &ext_session_lock_v1_interface_data};

struct wl_message const mw::SessionLockManagerV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types},
    {"lock", "n", lock_types}};

void const* mw::SessionLockManagerV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk,
    (void*)Thunks::lock_thunk};

mw::SessionLockManagerV1* mw::SessionLockManagerV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &ext_session_lock_manager_v1_interface_data, SessionLockManagerV1::Thunks::request_vtable))
    {
        return static_cast<SessionLockManagerV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// SessionLockV1

struct mw::SessionLockV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "SessionLockV1::destroy()");
        }
    }

    static void get_lock_surface_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id, struct wl_resource* surface, struct wl_resource* output)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &ext_session_lock_surface_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<SessionLockV1*>(wl_resource_get_user_data(resource));
            me->get_lock_surface(id_resolved, surface, output);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "SessionLockV1::get_lock_surface()");
        }
    }

    static void unlock_and_destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "SessionLockV1::unlock_and_destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<SessionLockV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_interface const* get_lock_surface_types[];
    static struct wl_message const request_messages[];
    static struct wl_message const event_messages[];
    static void const* request_vtable[];
};

int const mw::SessionLockV1::Thunks::supported_version = 1;

mw::SessionLockV1::SessionLockV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::SessionLockV1::~SessionLockV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

void mw::SessionLockV1::send_locked_event() const
{
    wl_resource_post_event(resource, Opcode::locked);
}

void mw::SessionLockV1::send_finished_event() const
{
    wl_resource_post_event(resource, Opcode::finished);
}

bool mw::SessionLockV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &ext_session_lock_v1_interface_data, Thunks::request_vtable);
}

uint32_t const mw::SessionLockV1::Error::invalid_destroy;
uint32_t const mw::SessionLockV1::Error::invalid_unlock;
uint32_t const mw::SessionLockV1::Error::role;
uint32_t const mw::SessionLockV1::Error::duplicate_output;
uint32_t const mw::SessionLockV1::Error::already_constructed;

struct wl_interface const* mw::SessionLockV1::Thunks::get_lock_surface_types[] {
    &ext_session_lock_surface_v1_interface_data,
    &wl_surface_interface_data,
    &wl_output_interface_data};

struct wl_message const mw::SessionLockV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types},
    {"get_lock_surface", "noo", get_lock_surface_types},
    {"unlock_and_destroy", "", all_null_types}};

struct wl_message const mw::SessionLockV1::Thunks::event_messages[] {
    {"locked", "", all_null_types},
    {"finished", "", all_null_types}};

void const* mw::SessionLockV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk,
    (void*)Thunks::get_lock_surface_thunk,
    (void*)Thunks::unlock_and_destroy_thunk};

mw::SessionLockV1* mw::SessionLockV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &ext_session_lock_v1_interface_data, SessionLockV1::Thunks::request_vtable))
    {
        return static_cast<SessionLockV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// SessionLockSurfaceV1

struct mw::SessionLockSurfaceV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "SessionLockSurfaceV1::destroy()");
        }
    }

    static void ack_configure_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t serial)
    {
        try
        {
            auto me = static_cast<SessionLockSurfaceV1*>(wl_resource_get_user_data(resource));
            me->ack_configure(serial);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "SessionLockSurfaceV1::ack_configure()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<SessionLockSurfaceV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_message const request_messages[];
    static struct wl_message const event_messages[];
    static void const* request_vtable[];
};

int const mw::SessionLockSurfaceV1::Thunks::supported_version = 1;

mw::SessionLockSurfaceV1::SessionLockSurfaceV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::SessionLockSurfaceV1::~SessionLockSurfaceV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

void mw::SessionLockSurfaceV1::send_configure_event(uint32_t serial, uint32_t width, uint32_t height) const
{
    wl_resource_post_event(resource, Opcode::configure, serial, width, height);
}

bool mw::SessionLockSurfaceV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &ext_session_lock_surface_v1_interface_data, Thunks::request_vtable);
}

uint32_t const mw::SessionLockSurfaceV1::Error::commit_before_first_ack;
uint32_t const mw::SessionLockSurfaceV1::Error::null_buffer;
uint32_t const mw::SessionLockSurfaceV1::Error::dimensions_mismatch;
uint32_t const mw::SessionLockSurfaceV1::Error::invalid_serial;

struct wl_message const mw::SessionLockSurfaceV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types},
    {"ack_configure", "u", all_null_types}};

struct wl_message const mw::SessionLockSurfaceV1::Thunks::event_messages[] {
    {"configure", "uuu", all_null_types}};

void const* mw::SessionLockSurfaceV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk,
    (void*)Thunks::ack_configure_thunk};

mw::SessionLockSurfaceV1* mw::SessionLockSurfaceV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &ext_session_lock_surface_v1_interface_data, SessionLockSurfaceV1::Thunks::request_vtable))
    {
        return static_cast<SessionLockSurfaceV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

namespace mir
{
namespace wayland
{

struct wl_interface const ext_session_lock_manager_v1_interface_data {
    mw::SessionLockManagerV1::interface_name,
    mw::SessionLockManagerV1::Thunks::supported_version,
    2, mw::SessionLockManagerV1::Thunks::request_messages,
    0, nullptr};

struct wl_interface const ext_session_lock_v1_interface_data {
    mw::SessionLockV1::interface_name,
    mw::SessionLockV1::Thunks::supported_version,
    3, mw::SessionLockV1::Thunks::request_messages,
    2, mw::SessionLockV1::Thunks::event_messages};

struct wl_interface const ext_session_lock_surface_v1_interface_data {
    mw::SessionLockSurfaceV1::interface_name,
    mw::SessionLockSurfaceV1::Thunks::supported_version,
    2, mw::SessionLockSurfaceV1::Thunks::request_messages,
    1, mw::SessionLockSurfaceV1::Thunks::event_messages};

}
}
