/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from idle-inhibit-unstable-v1.xml by mir_wayland_generator
 */

#include "idle-inhibit-unstable-v1_wrapper.h"

#include <boost/exception/diagnostic_information.hpp>
#include <wayland-server-core.h>

#include "mir/log.h"
#include "mir/wayland/protocol_error.h"
#include "mir/wayland/client.h"

namespace mir
{
namespace wayland
{
extern struct wl_interface const wl_surface_interface_data;
extern struct wl_interface const zwp_idle_inhibit_manager_v1_interface_data;
extern struct wl_interface const zwp_idle_inhibitor_v1_interface_data;
}
}

namespace mw = mir::wayland;

namespace
{
struct wl_interface const* all_null_types [] {
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr};
}

// IdleInhibitManagerV1

struct mw::IdleInhibitManagerV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "IdleInhibitManagerV1::destroy()");
        }
    }

    static void create_inhibitor_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id, struct wl_resource* surface)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &zwp_idle_inhibitor_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<IdleInhibitManagerV1*>(wl_resource_get_user_data(resource));
            me->create_inhibitor(id_resolved, surface);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "IdleInhibitManagerV1::create_inhibitor()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<IdleInhibitManagerV1*>(wl_resource_get_user_data(resource));
    }

    static void bind_thunk(struct wl_client* client, void* data, uint32_t version, uint32_t id)
    {
        auto me = static_cast<IdleInhibitManagerV1::Global*>(data);
        auto resource = wl_resource_create(
            client,
            &zwp_idle_inhibit_manager_v1_interface_data,
            std::min((int)version, Thunks::supported_version),
            id);
        if (resource == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            me->bind(resource);
        }
        catch(...)
        {
            internal_error_processing_request(client, "IdleInhibitManagerV1 global bind");
        }
    }

    static struct wl_interface const* create_inhibitor_types[];
    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::IdleInhibitManagerV1::Thunks::supported_version = 1;

mw::IdleInhibitManagerV1::IdleInhibitManagerV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::IdleInhibitManagerV1::~IdleInhibitManagerV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::IdleInhibitManagerV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwp_idle_inhibit_manager_v1_interface_data, Thunks::request_vtable);
}

mw::IdleInhibitManagerV1::Global::Global(wl_display* display, Version<1>)
    : wayland::Global{
          wl_global_create(
              display,
              &zwp_idle_inhibit_manager_v1_interface_data,
              Thunks::supported_version,
              this,
              &Thunks::bind_thunk)}
{
}

auto mw::IdleInhibitManagerV1::Global::interface_name() const -> char const*
{
    return IdleInhibitManagerV1::interface_name;
}

struct wl_interface const* mw::IdleInhibitManagerV1::Thunks::create_inhibitor_types[] {
    &zwp_idle_inhibitor_v1_interface_data,
    &wl_surface_interface_data};

struct wl_message const mw::IdleInhibitManagerV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types},
    {"create_inhibitor", "no", create_inhibitor_types}};

void const* mw::IdleInhibitManagerV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk,
    (void*)Thunks::create_inhibitor_thunk};

mw::IdleInhibitManagerV1* mw::IdleInhibitManagerV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwp_idle_inhibit_manager_v1_interface_data, IdleInhibitManagerV1::Thunks::request_vtable))
    {
        return static_cast<IdleInhibitManagerV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// IdleInhibitorV1

struct mw::IdleInhibitorV1::Thunks
{
    static int const supported_version;

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "IdleInhibitorV1::destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<IdleInhibitorV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::IdleInhibitorV1::Thunks::supported_version = 1;

mw::IdleInhibitorV1::IdleInhibitorV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::IdleInhibitorV1::~IdleInhibitorV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::IdleInhibitorV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwp_idle_inhibitor_v1_interface_data, Thunks::request_vtable);
}

struct wl_message const mw::IdleInhibitorV1::Thunks::request_messages[] {
    {"destroy", "", all_null_types}};

void const* mw::IdleInhibitorV1::Thunks::request_vtable[] {
    (void*)Thunks::destroy_thunk};

mw::IdleInhibitorV1* mw::IdleInhibitorV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwp_idle_inhibitor_v1_interface_data, IdleInhibitorV1::Thunks::request_vtable))
    {
        return static_cast<IdleInhibitorV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

namespace mir
{
namespace wayland
{

struct wl_interface const zwp_idle_inhibit_manager_v1_interface_data {
    mw::IdleInhibitManagerV1::interface_name,
    mw::IdleInhibitManagerV1::Thunks::supported_version,
    2, mw::IdleInhibitManagerV1::Thunks::request_messages,
    0, nullptr};

struct wl_interface const zwp_idle_inhibitor_v1_interface_data {
    mw::IdleInhibitorV1::interface_name,
    mw::IdleInhibitorV1::Thunks::supported_version,
    1, mw::IdleInhibitorV1::Thunks::request_messages,
    0, nullptr};

}
}
