/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from primary-selection-unstable-v1.xml by mir_wayland_generator
 */

#include "primary-selection-unstable-v1_wrapper.h"

#include <boost/exception/diagnostic_information.hpp>
#include <wayland-server-core.h>

#include "mir/log.h"
#include "mir/wayland/protocol_error.h"
#include "mir/wayland/client.h"

namespace mir
{
namespace wayland
{
extern struct wl_interface const wl_seat_interface_data;
extern struct wl_interface const zwp_primary_selection_device_manager_v1_interface_data;
extern struct wl_interface const zwp_primary_selection_device_v1_interface_data;
extern struct wl_interface const zwp_primary_selection_offer_v1_interface_data;
extern struct wl_interface const zwp_primary_selection_source_v1_interface_data;
}
}

namespace mw = mir::wayland;

namespace
{
struct wl_interface const* all_null_types [] {
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr};
}

// PrimarySelectionDeviceManagerV1

struct mw::PrimarySelectionDeviceManagerV1::Thunks
{
    static int const supported_version;

    static void create_source_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &zwp_primary_selection_source_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<PrimarySelectionDeviceManagerV1*>(wl_resource_get_user_data(resource));
            me->create_source(id_resolved);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "PrimarySelectionDeviceManagerV1::create_source()");
        }
    }

    static void get_device_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id, struct wl_resource* seat)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &zwp_primary_selection_device_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<PrimarySelectionDeviceManagerV1*>(wl_resource_get_user_data(resource));
            me->get_device(id_resolved, seat);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "PrimarySelectionDeviceManagerV1::get_device()");
        }
    }

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "PrimarySelectionDeviceManagerV1::destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<PrimarySelectionDeviceManagerV1*>(wl_resource_get_user_data(resource));
    }

    static void bind_thunk(struct wl_client* client, void* data, uint32_t version, uint32_t id)
    {
        auto me = static_cast<PrimarySelectionDeviceManagerV1::Global*>(data);
        auto resource = wl_resource_create(
            client,
            &zwp_primary_selection_device_manager_v1_interface_data,
            std::min((int)version, Thunks::supported_version),
            id);
        if (resource == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            me->bind(resource);
        }
        catch(...)
        {
            internal_error_processing_request(client, "PrimarySelectionDeviceManagerV1 global bind");
        }
    }

    static struct wl_interface const* create_source_types[];
    static struct wl_interface const* get_device_types[];
    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::PrimarySelectionDeviceManagerV1::Thunks::supported_version = 1;

mw::PrimarySelectionDeviceManagerV1::PrimarySelectionDeviceManagerV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::PrimarySelectionDeviceManagerV1::~PrimarySelectionDeviceManagerV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::PrimarySelectionDeviceManagerV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwp_primary_selection_device_manager_v1_interface_data, Thunks::request_vtable);
}

mw::PrimarySelectionDeviceManagerV1::Global::Global(wl_display* display, Version<1>)
    : wayland::Global{
          wl_global_create(
              display,
              &zwp_primary_selection_device_manager_v1_interface_data,
              Thunks::supported_version,
              this,
              &Thunks::bind_thunk)}
{
}

auto mw::PrimarySelectionDeviceManagerV1::Global::interface_name() const -> char const*
{
    return PrimarySelectionDeviceManagerV1::interface_name;
}

struct wl_interface const* mw::PrimarySelectionDeviceManagerV1::Thunks::create_source_types[] {
    &zwp_primary_selection_source_v1_interface_data};

struct wl_interface const* mw::PrimarySelectionDeviceManagerV1::Thunks::get_device_types[] {
    &zwp_primary_selection_device_v1_interface_data,
    &wl_seat_interface_data};

struct wl_message const mw::PrimarySelectionDeviceManagerV1::Thunks::request_messages[] {
    {"create_source", "n", create_source_types},
    {"get_device", "no", get_device_types},
    {"destroy", "", all_null_types}};

void const* mw::PrimarySelectionDeviceManagerV1::Thunks::request_vtable[] {
    (void*)Thunks::create_source_thunk,
    (void*)Thunks::get_device_thunk,
    (void*)Thunks::destroy_thunk};

mw::PrimarySelectionDeviceManagerV1* mw::PrimarySelectionDeviceManagerV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwp_primary_selection_device_manager_v1_interface_data, PrimarySelectionDeviceManagerV1::Thunks::request_vtable))
    {
        return static_cast<PrimarySelectionDeviceManagerV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// PrimarySelectionDeviceV1

struct mw::PrimarySelectionDeviceV1::Thunks
{
    static int const supported_version;

    static void set_selection_thunk(struct wl_client* client, struct wl_resource* resource, struct wl_resource* source, uint32_t serial)
    {
        std::optional<struct wl_resource*> source_resolved;
        if (source != nullptr)
        {
            source_resolved = {source};
        }
        try
        {
            auto me = static_cast<PrimarySelectionDeviceV1*>(wl_resource_get_user_data(resource));
            me->set_selection(source_resolved, serial);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "PrimarySelectionDeviceV1::set_selection()");
        }
    }

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "PrimarySelectionDeviceV1::destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<PrimarySelectionDeviceV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_interface const* set_selection_types[];
    static struct wl_interface const* data_offer_types[];
    static struct wl_interface const* selection_types[];
    static struct wl_message const request_messages[];
    static struct wl_message const event_messages[];
    static void const* request_vtable[];
};

int const mw::PrimarySelectionDeviceV1::Thunks::supported_version = 1;

mw::PrimarySelectionDeviceV1::PrimarySelectionDeviceV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::PrimarySelectionDeviceV1::~PrimarySelectionDeviceV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

void mw::PrimarySelectionDeviceV1::send_data_offer_event(struct wl_resource* offer) const
{
    wl_resource_post_event(resource, Opcode::data_offer, offer);
}

void mw::PrimarySelectionDeviceV1::send_selection_event(std::optional<struct wl_resource*> const& id) const
{
    struct wl_resource* id_resolved = nullptr;
    if (id)
    {
        id_resolved = id.value();
    }
    wl_resource_post_event(resource, Opcode::selection, id_resolved);
}

bool mw::PrimarySelectionDeviceV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwp_primary_selection_device_v1_interface_data, Thunks::request_vtable);
}

struct wl_interface const* mw::PrimarySelectionDeviceV1::Thunks::set_selection_types[] {
    &zwp_primary_selection_source_v1_interface_data,
    nullptr};

struct wl_interface const* mw::PrimarySelectionDeviceV1::Thunks::data_offer_types[] {
    &zwp_primary_selection_offer_v1_interface_data};

struct wl_interface const* mw::PrimarySelectionDeviceV1::Thunks::selection_types[] {
    &zwp_primary_selection_offer_v1_interface_data};

struct wl_message const mw::PrimarySelectionDeviceV1::Thunks::request_messages[] {
    {"set_selection", "?ou", set_selection_types},
    {"destroy", "", all_null_types}};

struct wl_message const mw::PrimarySelectionDeviceV1::Thunks::event_messages[] {
    {"data_offer", "n", data_offer_types},
    {"selection", "?o", selection_types}};

void const* mw::PrimarySelectionDeviceV1::Thunks::request_vtable[] {
    (void*)Thunks::set_selection_thunk,
    (void*)Thunks::destroy_thunk};

mw::PrimarySelectionDeviceV1* mw::PrimarySelectionDeviceV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwp_primary_selection_device_v1_interface_data, PrimarySelectionDeviceV1::Thunks::request_vtable))
    {
        return static_cast<PrimarySelectionDeviceV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// PrimarySelectionOfferV1

struct mw::PrimarySelectionOfferV1::Thunks
{
    static int const supported_version;

    static void receive_thunk(struct wl_client* client, struct wl_resource* resource, char const* mime_type, int32_t fd)
    {
        mir::Fd fd_resolved{fd};
        try
        {
            auto me = static_cast<PrimarySelectionOfferV1*>(wl_resource_get_user_data(resource));
            me->receive(mime_type, fd_resolved);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "PrimarySelectionOfferV1::receive()");
        }
    }

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "PrimarySelectionOfferV1::destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<PrimarySelectionOfferV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_message const request_messages[];
    static struct wl_message const event_messages[];
    static void const* request_vtable[];
};

int const mw::PrimarySelectionOfferV1::Thunks::supported_version = 1;

mw::PrimarySelectionOfferV1::PrimarySelectionOfferV1(PrimarySelectionDeviceV1 const& parent)
    : Resource{wl_resource_create(
          wl_resource_get_client(parent.resource),
          &zwp_primary_selection_offer_v1_interface_data,
          wl_resource_get_version(parent.resource), 0)}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::PrimarySelectionOfferV1::~PrimarySelectionOfferV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

void mw::PrimarySelectionOfferV1::send_offer_event(std::string const& mime_type) const
{
    const char* mime_type_resolved = mime_type.c_str();
    wl_resource_post_event(resource, Opcode::offer, mime_type_resolved);
}

bool mw::PrimarySelectionOfferV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwp_primary_selection_offer_v1_interface_data, Thunks::request_vtable);
}

struct wl_message const mw::PrimarySelectionOfferV1::Thunks::request_messages[] {
    {"receive", "sh", all_null_types},
    {"destroy", "", all_null_types}};

struct wl_message const mw::PrimarySelectionOfferV1::Thunks::event_messages[] {
    {"offer", "s", all_null_types}};

void const* mw::PrimarySelectionOfferV1::Thunks::request_vtable[] {
    (void*)Thunks::receive_thunk,
    (void*)Thunks::destroy_thunk};

mw::PrimarySelectionOfferV1* mw::PrimarySelectionOfferV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwp_primary_selection_offer_v1_interface_data, PrimarySelectionOfferV1::Thunks::request_vtable))
    {
        return static_cast<PrimarySelectionOfferV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// PrimarySelectionSourceV1

struct mw::PrimarySelectionSourceV1::Thunks
{
    static int const supported_version;

    static void offer_thunk(struct wl_client* client, struct wl_resource* resource, char const* mime_type)
    {
        try
        {
            auto me = static_cast<PrimarySelectionSourceV1*>(wl_resource_get_user_data(resource));
            me->offer(mime_type);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "PrimarySelectionSourceV1::offer()");
        }
    }

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "PrimarySelectionSourceV1::destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<PrimarySelectionSourceV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_message const request_messages[];
    static struct wl_message const event_messages[];
    static void const* request_vtable[];
};

int const mw::PrimarySelectionSourceV1::Thunks::supported_version = 1;

mw::PrimarySelectionSourceV1::PrimarySelectionSourceV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::PrimarySelectionSourceV1::~PrimarySelectionSourceV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

void mw::PrimarySelectionSourceV1::send_send_event(std::string const& mime_type, mir::Fd fd) const
{
    const char* mime_type_resolved = mime_type.c_str();
    int32_t fd_resolved{fd};
    wl_resource_post_event(resource, Opcode::send, mime_type_resolved, fd_resolved);
}

void mw::PrimarySelectionSourceV1::send_cancelled_event() const
{
    wl_resource_post_event(resource, Opcode::cancelled);
}

bool mw::PrimarySelectionSourceV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwp_primary_selection_source_v1_interface_data, Thunks::request_vtable);
}

struct wl_message const mw::PrimarySelectionSourceV1::Thunks::request_messages[] {
    {"offer", "s", all_null_types},
    {"destroy", "", all_null_types}};

struct wl_message const mw::PrimarySelectionSourceV1::Thunks::event_messages[] {
    {"send", "sh", all_null_types},
    {"cancelled", "", all_null_types}};

void const* mw::PrimarySelectionSourceV1::Thunks::request_vtable[] {
    (void*)Thunks::offer_thunk,
    (void*)Thunks::destroy_thunk};

mw::PrimarySelectionSourceV1* mw::PrimarySelectionSourceV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwp_primary_selection_source_v1_interface_data, PrimarySelectionSourceV1::Thunks::request_vtable))
    {
        return static_cast<PrimarySelectionSourceV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

namespace mir
{
namespace wayland
{

struct wl_interface const zwp_primary_selection_device_manager_v1_interface_data {
    mw::PrimarySelectionDeviceManagerV1::interface_name,
    mw::PrimarySelectionDeviceManagerV1::Thunks::supported_version,
    3, mw::PrimarySelectionDeviceManagerV1::Thunks::request_messages,
    0, nullptr};

struct wl_interface const zwp_primary_selection_device_v1_interface_data {
    mw::PrimarySelectionDeviceV1::interface_name,
    mw::PrimarySelectionDeviceV1::Thunks::supported_version,
    2, mw::PrimarySelectionDeviceV1::Thunks::request_messages,
    2, mw::PrimarySelectionDeviceV1::Thunks::event_messages};

struct wl_interface const zwp_primary_selection_offer_v1_interface_data {
    mw::PrimarySelectionOfferV1::interface_name,
    mw::PrimarySelectionOfferV1::Thunks::supported_version,
    2, mw::PrimarySelectionOfferV1::Thunks::request_messages,
    1, mw::PrimarySelectionOfferV1::Thunks::event_messages};

struct wl_interface const zwp_primary_selection_source_v1_interface_data {
    mw::PrimarySelectionSourceV1::interface_name,
    mw::PrimarySelectionSourceV1::Thunks::supported_version,
    2, mw::PrimarySelectionSourceV1::Thunks::request_messages,
    2, mw::PrimarySelectionSourceV1::Thunks::event_messages};

}
}
