/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from text-input-unstable-v1.xml by mir_wayland_generator
 */

#include "text-input-unstable-v1_wrapper.h"

#include <boost/exception/diagnostic_information.hpp>
#include <wayland-server-core.h>

#include "mir/log.h"
#include "mir/wayland/protocol_error.h"
#include "mir/wayland/client.h"

namespace mir
{
namespace wayland
{
extern struct wl_interface const wl_seat_interface_data;
extern struct wl_interface const wl_surface_interface_data;
extern struct wl_interface const zwp_text_input_manager_v1_interface_data;
extern struct wl_interface const zwp_text_input_v1_interface_data;
}
}

namespace mw = mir::wayland;

namespace
{
struct wl_interface const* all_null_types [] {
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr};
}

// TextInputV1

struct mw::TextInputV1::Thunks
{
    static int const supported_version;

    static void activate_thunk(struct wl_client* client, struct wl_resource* resource, struct wl_resource* seat, struct wl_resource* surface)
    {
        try
        {
            auto me = static_cast<TextInputV1*>(wl_resource_get_user_data(resource));
            me->activate(seat, surface);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "TextInputV1::activate()");
        }
    }

    static void deactivate_thunk(struct wl_client* client, struct wl_resource* resource, struct wl_resource* seat)
    {
        try
        {
            auto me = static_cast<TextInputV1*>(wl_resource_get_user_data(resource));
            me->deactivate(seat);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "TextInputV1::deactivate()");
        }
    }

    static void show_input_panel_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<TextInputV1*>(wl_resource_get_user_data(resource));
            me->show_input_panel();
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "TextInputV1::show_input_panel()");
        }
    }

    static void hide_input_panel_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<TextInputV1*>(wl_resource_get_user_data(resource));
            me->hide_input_panel();
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "TextInputV1::hide_input_panel()");
        }
    }

    static void reset_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<TextInputV1*>(wl_resource_get_user_data(resource));
            me->reset();
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "TextInputV1::reset()");
        }
    }

    static void set_surrounding_text_thunk(struct wl_client* client, struct wl_resource* resource, char const* text, uint32_t cursor, uint32_t anchor)
    {
        try
        {
            auto me = static_cast<TextInputV1*>(wl_resource_get_user_data(resource));
            me->set_surrounding_text(text, cursor, anchor);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "TextInputV1::set_surrounding_text()");
        }
    }

    static void set_content_type_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t hint, uint32_t purpose)
    {
        try
        {
            auto me = static_cast<TextInputV1*>(wl_resource_get_user_data(resource));
            me->set_content_type(hint, purpose);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "TextInputV1::set_content_type()");
        }
    }

    static void set_cursor_rectangle_thunk(struct wl_client* client, struct wl_resource* resource, int32_t x, int32_t y, int32_t width, int32_t height)
    {
        try
        {
            auto me = static_cast<TextInputV1*>(wl_resource_get_user_data(resource));
            me->set_cursor_rectangle(x, y, width, height);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "TextInputV1::set_cursor_rectangle()");
        }
    }

    static void set_preferred_language_thunk(struct wl_client* client, struct wl_resource* resource, char const* language)
    {
        try
        {
            auto me = static_cast<TextInputV1*>(wl_resource_get_user_data(resource));
            me->set_preferred_language(language);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "TextInputV1::set_preferred_language()");
        }
    }

    static void commit_state_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t serial)
    {
        try
        {
            auto me = static_cast<TextInputV1*>(wl_resource_get_user_data(resource));
            me->commit_state(serial);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "TextInputV1::commit_state()");
        }
    }

    static void invoke_action_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t button, uint32_t index)
    {
        try
        {
            auto me = static_cast<TextInputV1*>(wl_resource_get_user_data(resource));
            me->invoke_action(button, index);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "TextInputV1::invoke_action()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<TextInputV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_interface const* activate_types[];
    static struct wl_interface const* deactivate_types[];
    static struct wl_interface const* enter_types[];
    static struct wl_message const request_messages[];
    static struct wl_message const event_messages[];
    static void const* request_vtable[];
};

int const mw::TextInputV1::Thunks::supported_version = 1;

mw::TextInputV1::TextInputV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::TextInputV1::~TextInputV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

void mw::TextInputV1::send_enter_event(struct wl_resource* surface) const
{
    wl_resource_post_event(resource, Opcode::enter, surface);
}

void mw::TextInputV1::send_leave_event() const
{
    wl_resource_post_event(resource, Opcode::leave);
}

void mw::TextInputV1::send_modifiers_map_event(struct wl_array* map) const
{
    wl_resource_post_event(resource, Opcode::modifiers_map, map);
}

void mw::TextInputV1::send_input_panel_state_event(uint32_t state) const
{
    wl_resource_post_event(resource, Opcode::input_panel_state, state);
}

void mw::TextInputV1::send_preedit_string_event(uint32_t serial, std::string const& text, std::string const& commit) const
{
    const char* text_resolved = text.c_str();
    const char* commit_resolved = commit.c_str();
    wl_resource_post_event(resource, Opcode::preedit_string, serial, text_resolved, commit_resolved);
}

void mw::TextInputV1::send_preedit_styling_event(uint32_t index, uint32_t length, uint32_t style) const
{
    wl_resource_post_event(resource, Opcode::preedit_styling, index, length, style);
}

void mw::TextInputV1::send_preedit_cursor_event(int32_t index) const
{
    wl_resource_post_event(resource, Opcode::preedit_cursor, index);
}

void mw::TextInputV1::send_commit_string_event(uint32_t serial, std::string const& text) const
{
    const char* text_resolved = text.c_str();
    wl_resource_post_event(resource, Opcode::commit_string, serial, text_resolved);
}

void mw::TextInputV1::send_cursor_position_event(int32_t index, int32_t anchor) const
{
    wl_resource_post_event(resource, Opcode::cursor_position, index, anchor);
}

void mw::TextInputV1::send_delete_surrounding_text_event(int32_t index, uint32_t length) const
{
    wl_resource_post_event(resource, Opcode::delete_surrounding_text, index, length);
}

void mw::TextInputV1::send_keysym_event(uint32_t serial, uint32_t time, uint32_t sym, uint32_t state, uint32_t modifiers) const
{
    wl_resource_post_event(resource, Opcode::keysym, serial, time, sym, state, modifiers);
}

void mw::TextInputV1::send_language_event(uint32_t serial, std::string const& language) const
{
    const char* language_resolved = language.c_str();
    wl_resource_post_event(resource, Opcode::language, serial, language_resolved);
}

void mw::TextInputV1::send_text_direction_event(uint32_t serial, uint32_t direction) const
{
    wl_resource_post_event(resource, Opcode::text_direction, serial, direction);
}

bool mw::TextInputV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwp_text_input_v1_interface_data, Thunks::request_vtable);
}

void mw::TextInputV1::destroy_and_delete() const
{
    // Will result in this object being deleted
    wl_resource_destroy(resource);
}

uint32_t const mw::TextInputV1::ContentHint::none;
uint32_t const mw::TextInputV1::ContentHint::default_;
uint32_t const mw::TextInputV1::ContentHint::password;
uint32_t const mw::TextInputV1::ContentHint::auto_completion;
uint32_t const mw::TextInputV1::ContentHint::auto_correction;
uint32_t const mw::TextInputV1::ContentHint::auto_capitalization;
uint32_t const mw::TextInputV1::ContentHint::lowercase;
uint32_t const mw::TextInputV1::ContentHint::uppercase;
uint32_t const mw::TextInputV1::ContentHint::titlecase;
uint32_t const mw::TextInputV1::ContentHint::hidden_text;
uint32_t const mw::TextInputV1::ContentHint::sensitive_data;
uint32_t const mw::TextInputV1::ContentHint::latin;
uint32_t const mw::TextInputV1::ContentHint::multiline;
uint32_t const mw::TextInputV1::ContentPurpose::normal;
uint32_t const mw::TextInputV1::ContentPurpose::alpha;
uint32_t const mw::TextInputV1::ContentPurpose::digits;
uint32_t const mw::TextInputV1::ContentPurpose::number;
uint32_t const mw::TextInputV1::ContentPurpose::phone;
uint32_t const mw::TextInputV1::ContentPurpose::url;
uint32_t const mw::TextInputV1::ContentPurpose::email;
uint32_t const mw::TextInputV1::ContentPurpose::name;
uint32_t const mw::TextInputV1::ContentPurpose::password;
uint32_t const mw::TextInputV1::ContentPurpose::date;
uint32_t const mw::TextInputV1::ContentPurpose::time;
uint32_t const mw::TextInputV1::ContentPurpose::datetime;
uint32_t const mw::TextInputV1::ContentPurpose::terminal;
uint32_t const mw::TextInputV1::PreeditStyle::default_;
uint32_t const mw::TextInputV1::PreeditStyle::none;
uint32_t const mw::TextInputV1::PreeditStyle::active;
uint32_t const mw::TextInputV1::PreeditStyle::inactive;
uint32_t const mw::TextInputV1::PreeditStyle::highlight;
uint32_t const mw::TextInputV1::PreeditStyle::underline;
uint32_t const mw::TextInputV1::PreeditStyle::selection;
uint32_t const mw::TextInputV1::PreeditStyle::incorrect;
uint32_t const mw::TextInputV1::TextDirection::auto_;
uint32_t const mw::TextInputV1::TextDirection::ltr;
uint32_t const mw::TextInputV1::TextDirection::rtl;

struct wl_interface const* mw::TextInputV1::Thunks::activate_types[] {
    &wl_seat_interface_data,
    &wl_surface_interface_data};

struct wl_interface const* mw::TextInputV1::Thunks::deactivate_types[] {
    &wl_seat_interface_data};

struct wl_interface const* mw::TextInputV1::Thunks::enter_types[] {
    &wl_surface_interface_data};

struct wl_message const mw::TextInputV1::Thunks::request_messages[] {
    {"activate", "oo", activate_types},
    {"deactivate", "o", deactivate_types},
    {"show_input_panel", "", all_null_types},
    {"hide_input_panel", "", all_null_types},
    {"reset", "", all_null_types},
    {"set_surrounding_text", "suu", all_null_types},
    {"set_content_type", "uu", all_null_types},
    {"set_cursor_rectangle", "iiii", all_null_types},
    {"set_preferred_language", "s", all_null_types},
    {"commit_state", "u", all_null_types},
    {"invoke_action", "uu", all_null_types}};

struct wl_message const mw::TextInputV1::Thunks::event_messages[] {
    {"enter", "o", enter_types},
    {"leave", "", all_null_types},
    {"modifiers_map", "a", all_null_types},
    {"input_panel_state", "u", all_null_types},
    {"preedit_string", "uss", all_null_types},
    {"preedit_styling", "uuu", all_null_types},
    {"preedit_cursor", "i", all_null_types},
    {"commit_string", "us", all_null_types},
    {"cursor_position", "ii", all_null_types},
    {"delete_surrounding_text", "iu", all_null_types},
    {"keysym", "uuuuu", all_null_types},
    {"language", "us", all_null_types},
    {"text_direction", "uu", all_null_types}};

void const* mw::TextInputV1::Thunks::request_vtable[] {
    (void*)Thunks::activate_thunk,
    (void*)Thunks::deactivate_thunk,
    (void*)Thunks::show_input_panel_thunk,
    (void*)Thunks::hide_input_panel_thunk,
    (void*)Thunks::reset_thunk,
    (void*)Thunks::set_surrounding_text_thunk,
    (void*)Thunks::set_content_type_thunk,
    (void*)Thunks::set_cursor_rectangle_thunk,
    (void*)Thunks::set_preferred_language_thunk,
    (void*)Thunks::commit_state_thunk,
    (void*)Thunks::invoke_action_thunk};

mw::TextInputV1* mw::TextInputV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwp_text_input_v1_interface_data, TextInputV1::Thunks::request_vtable))
    {
        return static_cast<TextInputV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// TextInputManagerV1

struct mw::TextInputManagerV1::Thunks
{
    static int const supported_version;

    static void create_text_input_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t id)
    {
        wl_resource* id_resolved{
            wl_resource_create(client, &zwp_text_input_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<TextInputManagerV1*>(wl_resource_get_user_data(resource));
            me->create_text_input(id_resolved);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "TextInputManagerV1::create_text_input()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<TextInputManagerV1*>(wl_resource_get_user_data(resource));
    }

    static void bind_thunk(struct wl_client* client, void* data, uint32_t version, uint32_t id)
    {
        auto me = static_cast<TextInputManagerV1::Global*>(data);
        auto resource = wl_resource_create(
            client,
            &zwp_text_input_manager_v1_interface_data,
            std::min((int)version, Thunks::supported_version),
            id);
        if (resource == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            me->bind(resource);
        }
        catch(...)
        {
            internal_error_processing_request(client, "TextInputManagerV1 global bind");
        }
    }

    static struct wl_interface const* create_text_input_types[];
    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::TextInputManagerV1::Thunks::supported_version = 1;

mw::TextInputManagerV1::TextInputManagerV1(struct wl_resource* resource, Version<1>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::TextInputManagerV1::~TextInputManagerV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::TextInputManagerV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwp_text_input_manager_v1_interface_data, Thunks::request_vtable);
}

void mw::TextInputManagerV1::destroy_and_delete() const
{
    // Will result in this object being deleted
    wl_resource_destroy(resource);
}

mw::TextInputManagerV1::Global::Global(wl_display* display, Version<1>)
    : wayland::Global{
          wl_global_create(
              display,
              &zwp_text_input_manager_v1_interface_data,
              Thunks::supported_version,
              this,
              &Thunks::bind_thunk)}
{
}

auto mw::TextInputManagerV1::Global::interface_name() const -> char const*
{
    return TextInputManagerV1::interface_name;
}

struct wl_interface const* mw::TextInputManagerV1::Thunks::create_text_input_types[] {
    &zwp_text_input_v1_interface_data};

struct wl_message const mw::TextInputManagerV1::Thunks::request_messages[] {
    {"create_text_input", "n", create_text_input_types}};

void const* mw::TextInputManagerV1::Thunks::request_vtable[] {
    (void*)Thunks::create_text_input_thunk};

mw::TextInputManagerV1* mw::TextInputManagerV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwp_text_input_manager_v1_interface_data, TextInputManagerV1::Thunks::request_vtable))
    {
        return static_cast<TextInputManagerV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

namespace mir
{
namespace wayland
{

struct wl_interface const zwp_text_input_v1_interface_data {
    mw::TextInputV1::interface_name,
    mw::TextInputV1::Thunks::supported_version,
    11, mw::TextInputV1::Thunks::request_messages,
    13, mw::TextInputV1::Thunks::event_messages};

struct wl_interface const zwp_text_input_manager_v1_interface_data {
    mw::TextInputManagerV1::interface_name,
    mw::TextInputManagerV1::Thunks::supported_version,
    1, mw::TextInputManagerV1::Thunks::request_messages,
    0, nullptr};

}
}
