/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from wlr-screencopy-unstable-v1.xml by mir_wayland_generator
 */

#include "wlr-screencopy-unstable-v1_wrapper.h"

#include <boost/exception/diagnostic_information.hpp>
#include <wayland-server-core.h>

#include "mir/log.h"
#include "mir/wayland/protocol_error.h"
#include "mir/wayland/client.h"

namespace mir
{
namespace wayland
{
extern struct wl_interface const wl_buffer_interface_data;
extern struct wl_interface const wl_output_interface_data;
extern struct wl_interface const zwlr_screencopy_frame_v1_interface_data;
extern struct wl_interface const zwlr_screencopy_manager_v1_interface_data;
}
}

namespace mw = mir::wayland;

namespace
{
struct wl_interface const* all_null_types [] {
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr};
}

// WlrScreencopyManagerV1

struct mw::WlrScreencopyManagerV1::Thunks
{
    static int const supported_version;

    static void capture_output_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t frame, int32_t overlay_cursor, struct wl_resource* output)
    {
        wl_resource* frame_resolved{
            wl_resource_create(client, &zwlr_screencopy_frame_v1_interface_data, wl_resource_get_version(resource), frame)};
        if (frame_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<WlrScreencopyManagerV1*>(wl_resource_get_user_data(resource));
            me->capture_output(frame_resolved, overlay_cursor, output);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "WlrScreencopyManagerV1::capture_output()");
        }
    }

    static void capture_output_region_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t frame, int32_t overlay_cursor, struct wl_resource* output, int32_t x, int32_t y, int32_t width, int32_t height)
    {
        wl_resource* frame_resolved{
            wl_resource_create(client, &zwlr_screencopy_frame_v1_interface_data, wl_resource_get_version(resource), frame)};
        if (frame_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<WlrScreencopyManagerV1*>(wl_resource_get_user_data(resource));
            me->capture_output_region(frame_resolved, overlay_cursor, output, x, y, width, height);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "WlrScreencopyManagerV1::capture_output_region()");
        }
    }

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "WlrScreencopyManagerV1::destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<WlrScreencopyManagerV1*>(wl_resource_get_user_data(resource));
    }

    static void bind_thunk(struct wl_client* client, void* data, uint32_t version, uint32_t id)
    {
        auto me = static_cast<WlrScreencopyManagerV1::Global*>(data);
        auto resource = wl_resource_create(
            client,
            &zwlr_screencopy_manager_v1_interface_data,
            std::min((int)version, Thunks::supported_version),
            id);
        if (resource == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            me->bind(resource);
        }
        catch(...)
        {
            internal_error_processing_request(client, "WlrScreencopyManagerV1 global bind");
        }
    }

    static struct wl_interface const* capture_output_types[];
    static struct wl_interface const* capture_output_region_types[];
    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::WlrScreencopyManagerV1::Thunks::supported_version = 3;

mw::WlrScreencopyManagerV1::WlrScreencopyManagerV1(struct wl_resource* resource, Version<3>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::WlrScreencopyManagerV1::~WlrScreencopyManagerV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::WlrScreencopyManagerV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwlr_screencopy_manager_v1_interface_data, Thunks::request_vtable);
}

mw::WlrScreencopyManagerV1::Global::Global(wl_display* display, Version<3>)
    : wayland::Global{
          wl_global_create(
              display,
              &zwlr_screencopy_manager_v1_interface_data,
              Thunks::supported_version,
              this,
              &Thunks::bind_thunk)}
{
}

auto mw::WlrScreencopyManagerV1::Global::interface_name() const -> char const*
{
    return WlrScreencopyManagerV1::interface_name;
}

struct wl_interface const* mw::WlrScreencopyManagerV1::Thunks::capture_output_types[] {
    &zwlr_screencopy_frame_v1_interface_data,
    nullptr,
    &wl_output_interface_data};

struct wl_interface const* mw::WlrScreencopyManagerV1::Thunks::capture_output_region_types[] {
    &zwlr_screencopy_frame_v1_interface_data,
    nullptr,
    &wl_output_interface_data,
    nullptr,
    nullptr,
    nullptr,
    nullptr};

struct wl_message const mw::WlrScreencopyManagerV1::Thunks::request_messages[] {
    {"capture_output", "nio", capture_output_types},
    {"capture_output_region", "nioiiii", capture_output_region_types},
    {"destroy", "", all_null_types}};

void const* mw::WlrScreencopyManagerV1::Thunks::request_vtable[] {
    (void*)Thunks::capture_output_thunk,
    (void*)Thunks::capture_output_region_thunk,
    (void*)Thunks::destroy_thunk};

mw::WlrScreencopyManagerV1* mw::WlrScreencopyManagerV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwlr_screencopy_manager_v1_interface_data, WlrScreencopyManagerV1::Thunks::request_vtable))
    {
        return static_cast<WlrScreencopyManagerV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// WlrScreencopyFrameV1

struct mw::WlrScreencopyFrameV1::Thunks
{
    static int const supported_version;

    static void copy_thunk(struct wl_client* client, struct wl_resource* resource, struct wl_resource* buffer)
    {
        try
        {
            auto me = static_cast<WlrScreencopyFrameV1*>(wl_resource_get_user_data(resource));
            me->copy(buffer);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "WlrScreencopyFrameV1::copy()");
        }
    }

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "WlrScreencopyFrameV1::destroy()");
        }
    }

    static void copy_with_damage_thunk(struct wl_client* client, struct wl_resource* resource, struct wl_resource* buffer)
    {
        try
        {
            auto me = static_cast<WlrScreencopyFrameV1*>(wl_resource_get_user_data(resource));
            me->copy_with_damage(buffer);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "WlrScreencopyFrameV1::copy_with_damage()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<WlrScreencopyFrameV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_interface const* copy_types[];
    static struct wl_interface const* copy_with_damage_types[];
    static struct wl_message const request_messages[];
    static struct wl_message const event_messages[];
    static void const* request_vtable[];
};

int const mw::WlrScreencopyFrameV1::Thunks::supported_version = 3;

mw::WlrScreencopyFrameV1::WlrScreencopyFrameV1(struct wl_resource* resource, Version<3>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::WlrScreencopyFrameV1::~WlrScreencopyFrameV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

void mw::WlrScreencopyFrameV1::send_buffer_event(uint32_t format, uint32_t width, uint32_t height, uint32_t stride) const
{
    wl_resource_post_event(resource, Opcode::buffer, format, width, height, stride);
}

void mw::WlrScreencopyFrameV1::send_flags_event(uint32_t flags) const
{
    wl_resource_post_event(resource, Opcode::flags, flags);
}

void mw::WlrScreencopyFrameV1::send_ready_event(uint32_t tv_sec_hi, uint32_t tv_sec_lo, uint32_t tv_nsec) const
{
    wl_resource_post_event(resource, Opcode::ready, tv_sec_hi, tv_sec_lo, tv_nsec);
}

void mw::WlrScreencopyFrameV1::send_failed_event() const
{
    wl_resource_post_event(resource, Opcode::failed);
}

bool mw::WlrScreencopyFrameV1::version_supports_damage()
{
    return wl_resource_get_version(resource) >= 2;
}

void mw::WlrScreencopyFrameV1::send_damage_event_if_supported(uint32_t x, uint32_t y, uint32_t width, uint32_t height) const
{
    if (wl_resource_get_version(resource) >= 2)
    {
        wl_resource_post_event(resource, Opcode::damage, x, y, width, height);
    }
}

void mw::WlrScreencopyFrameV1::send_damage_event(uint32_t x, uint32_t y, uint32_t width, uint32_t height) const
{
    if (wl_resource_get_version(resource) >= 2)
    {
        wl_resource_post_event(resource, Opcode::damage, x, y, width, height);
    }
    else
    {
        tried_to_send_unsupported_event(client->raw_client(), resource, "damage", 2);
    }
}

bool mw::WlrScreencopyFrameV1::version_supports_linux_dmabuf()
{
    return wl_resource_get_version(resource) >= 3;
}

void mw::WlrScreencopyFrameV1::send_linux_dmabuf_event_if_supported(uint32_t format, uint32_t width, uint32_t height) const
{
    if (wl_resource_get_version(resource) >= 3)
    {
        wl_resource_post_event(resource, Opcode::linux_dmabuf, format, width, height);
    }
}

void mw::WlrScreencopyFrameV1::send_linux_dmabuf_event(uint32_t format, uint32_t width, uint32_t height) const
{
    if (wl_resource_get_version(resource) >= 3)
    {
        wl_resource_post_event(resource, Opcode::linux_dmabuf, format, width, height);
    }
    else
    {
        tried_to_send_unsupported_event(client->raw_client(), resource, "linux_dmabuf", 3);
    }
}

bool mw::WlrScreencopyFrameV1::version_supports_buffer_done()
{
    return wl_resource_get_version(resource) >= 3;
}

void mw::WlrScreencopyFrameV1::send_buffer_done_event_if_supported() const
{
    if (wl_resource_get_version(resource) >= 3)
    {
        wl_resource_post_event(resource, Opcode::buffer_done);
    }
}

void mw::WlrScreencopyFrameV1::send_buffer_done_event() const
{
    if (wl_resource_get_version(resource) >= 3)
    {
        wl_resource_post_event(resource, Opcode::buffer_done);
    }
    else
    {
        tried_to_send_unsupported_event(client->raw_client(), resource, "buffer_done", 3);
    }
}

bool mw::WlrScreencopyFrameV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwlr_screencopy_frame_v1_interface_data, Thunks::request_vtable);
}

uint32_t const mw::WlrScreencopyFrameV1::Error::already_used;
uint32_t const mw::WlrScreencopyFrameV1::Error::invalid_buffer;
uint32_t const mw::WlrScreencopyFrameV1::Flags::y_invert;

struct wl_interface const* mw::WlrScreencopyFrameV1::Thunks::copy_types[] {
    &wl_buffer_interface_data};

struct wl_interface const* mw::WlrScreencopyFrameV1::Thunks::copy_with_damage_types[] {
    &wl_buffer_interface_data};

struct wl_message const mw::WlrScreencopyFrameV1::Thunks::request_messages[] {
    {"copy", "o", copy_types},
    {"destroy", "", all_null_types},
    {"copy_with_damage", "2o", copy_with_damage_types}};

struct wl_message const mw::WlrScreencopyFrameV1::Thunks::event_messages[] {
    {"buffer", "uuuu", all_null_types},
    {"flags", "u", all_null_types},
    {"ready", "uuu", all_null_types},
    {"failed", "", all_null_types},
    {"damage", "2uuuu", all_null_types},
    {"linux_dmabuf", "3uuu", all_null_types},
    {"buffer_done", "3", all_null_types}};

void const* mw::WlrScreencopyFrameV1::Thunks::request_vtable[] {
    (void*)Thunks::copy_thunk,
    (void*)Thunks::destroy_thunk,
    (void*)Thunks::copy_with_damage_thunk};

mw::WlrScreencopyFrameV1* mw::WlrScreencopyFrameV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwlr_screencopy_frame_v1_interface_data, WlrScreencopyFrameV1::Thunks::request_vtable))
    {
        return static_cast<WlrScreencopyFrameV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

namespace mir
{
namespace wayland
{

struct wl_interface const zwlr_screencopy_manager_v1_interface_data {
    mw::WlrScreencopyManagerV1::interface_name,
    mw::WlrScreencopyManagerV1::Thunks::supported_version,
    3, mw::WlrScreencopyManagerV1::Thunks::request_messages,
    0, nullptr};

struct wl_interface const zwlr_screencopy_frame_v1_interface_data {
    mw::WlrScreencopyFrameV1::interface_name,
    mw::WlrScreencopyFrameV1::Thunks::supported_version,
    3, mw::WlrScreencopyFrameV1::Thunks::request_messages,
    7, mw::WlrScreencopyFrameV1::Thunks::event_messages};

}
}
