/*
 * AUTOGENERATED - DO NOT EDIT
 *
 * This file is generated from wlr-virtual-pointer-unstable-v1.xml by mir_wayland_generator
 */

#include "wlr-virtual-pointer-unstable-v1_wrapper.h"

#include <boost/exception/diagnostic_information.hpp>
#include <wayland-server-core.h>

#include "mir/log.h"
#include "mir/wayland/protocol_error.h"
#include "mir/wayland/client.h"

namespace mir
{
namespace wayland
{
extern struct wl_interface const wl_output_interface_data;
extern struct wl_interface const wl_seat_interface_data;
extern struct wl_interface const zwlr_virtual_pointer_manager_v1_interface_data;
extern struct wl_interface const zwlr_virtual_pointer_v1_interface_data;
}
}

namespace mw = mir::wayland;

namespace
{
struct wl_interface const* all_null_types [] {
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr};
}

// VirtualPointerV1

struct mw::VirtualPointerV1::Thunks
{
    static int const supported_version;

    static void motion_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t time, wl_fixed_t dx, wl_fixed_t dy)
    {
        double dx_resolved{wl_fixed_to_double(dx)};
        double dy_resolved{wl_fixed_to_double(dy)};
        try
        {
            auto me = static_cast<VirtualPointerV1*>(wl_resource_get_user_data(resource));
            me->motion(time, dx_resolved, dy_resolved);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "VirtualPointerV1::motion()");
        }
    }

    static void motion_absolute_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t time, uint32_t x, uint32_t y, uint32_t x_extent, uint32_t y_extent)
    {
        try
        {
            auto me = static_cast<VirtualPointerV1*>(wl_resource_get_user_data(resource));
            me->motion_absolute(time, x, y, x_extent, y_extent);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "VirtualPointerV1::motion_absolute()");
        }
    }

    static void button_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t time, uint32_t button, uint32_t state)
    {
        try
        {
            auto me = static_cast<VirtualPointerV1*>(wl_resource_get_user_data(resource));
            me->button(time, button, state);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "VirtualPointerV1::button()");
        }
    }

    static void axis_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t time, uint32_t axis, wl_fixed_t value)
    {
        double value_resolved{wl_fixed_to_double(value)};
        try
        {
            auto me = static_cast<VirtualPointerV1*>(wl_resource_get_user_data(resource));
            me->axis(time, axis, value_resolved);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "VirtualPointerV1::axis()");
        }
    }

    static void frame_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            auto me = static_cast<VirtualPointerV1*>(wl_resource_get_user_data(resource));
            me->frame();
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "VirtualPointerV1::frame()");
        }
    }

    static void axis_source_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t axis_source)
    {
        try
        {
            auto me = static_cast<VirtualPointerV1*>(wl_resource_get_user_data(resource));
            me->axis_source(axis_source);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "VirtualPointerV1::axis_source()");
        }
    }

    static void axis_stop_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t time, uint32_t axis)
    {
        try
        {
            auto me = static_cast<VirtualPointerV1*>(wl_resource_get_user_data(resource));
            me->axis_stop(time, axis);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "VirtualPointerV1::axis_stop()");
        }
    }

    static void axis_discrete_thunk(struct wl_client* client, struct wl_resource* resource, uint32_t time, uint32_t axis, wl_fixed_t value, int32_t discrete)
    {
        double value_resolved{wl_fixed_to_double(value)};
        try
        {
            auto me = static_cast<VirtualPointerV1*>(wl_resource_get_user_data(resource));
            me->axis_discrete(time, axis, value_resolved, discrete);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "VirtualPointerV1::axis_discrete()");
        }
    }

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "VirtualPointerV1::destroy()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<VirtualPointerV1*>(wl_resource_get_user_data(resource));
    }

    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::VirtualPointerV1::Thunks::supported_version = 2;

mw::VirtualPointerV1::VirtualPointerV1(struct wl_resource* resource, Version<2>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::VirtualPointerV1::~VirtualPointerV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::VirtualPointerV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwlr_virtual_pointer_v1_interface_data, Thunks::request_vtable);
}

uint32_t const mw::VirtualPointerV1::Error::invalid_axis;
uint32_t const mw::VirtualPointerV1::Error::invalid_axis_source;

struct wl_message const mw::VirtualPointerV1::Thunks::request_messages[] {
    {"motion", "uff", all_null_types},
    {"motion_absolute", "uuuuu", all_null_types},
    {"button", "uuu", all_null_types},
    {"axis", "uuf", all_null_types},
    {"frame", "", all_null_types},
    {"axis_source", "u", all_null_types},
    {"axis_stop", "uu", all_null_types},
    {"axis_discrete", "uufi", all_null_types},
    {"destroy", "1", all_null_types}};

void const* mw::VirtualPointerV1::Thunks::request_vtable[] {
    (void*)Thunks::motion_thunk,
    (void*)Thunks::motion_absolute_thunk,
    (void*)Thunks::button_thunk,
    (void*)Thunks::axis_thunk,
    (void*)Thunks::frame_thunk,
    (void*)Thunks::axis_source_thunk,
    (void*)Thunks::axis_stop_thunk,
    (void*)Thunks::axis_discrete_thunk,
    (void*)Thunks::destroy_thunk};

mw::VirtualPointerV1* mw::VirtualPointerV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwlr_virtual_pointer_v1_interface_data, VirtualPointerV1::Thunks::request_vtable))
    {
        return static_cast<VirtualPointerV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

// VirtualPointerManagerV1

struct mw::VirtualPointerManagerV1::Thunks
{
    static int const supported_version;

    static void create_virtual_pointer_thunk(struct wl_client* client, struct wl_resource* resource, struct wl_resource* seat, uint32_t id)
    {
        std::optional<struct wl_resource*> seat_resolved;
        if (seat != nullptr)
        {
            seat_resolved = {seat};
        }
        wl_resource* id_resolved{
            wl_resource_create(client, &zwlr_virtual_pointer_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<VirtualPointerManagerV1*>(wl_resource_get_user_data(resource));
            me->create_virtual_pointer(seat_resolved, id_resolved);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "VirtualPointerManagerV1::create_virtual_pointer()");
        }
    }

    static void destroy_thunk(struct wl_client* client, struct wl_resource* resource)
    {
        try
        {
            wl_resource_destroy(resource);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "VirtualPointerManagerV1::destroy()");
        }
    }

    static void create_virtual_pointer_with_output_thunk(struct wl_client* client, struct wl_resource* resource, struct wl_resource* seat, struct wl_resource* output, uint32_t id)
    {
        std::optional<struct wl_resource*> seat_resolved;
        if (seat != nullptr)
        {
            seat_resolved = {seat};
        }
        std::optional<struct wl_resource*> output_resolved;
        if (output != nullptr)
        {
            output_resolved = {output};
        }
        wl_resource* id_resolved{
            wl_resource_create(client, &zwlr_virtual_pointer_v1_interface_data, wl_resource_get_version(resource), id)};
        if (id_resolved == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            auto me = static_cast<VirtualPointerManagerV1*>(wl_resource_get_user_data(resource));
            me->create_virtual_pointer_with_output(seat_resolved, output_resolved, id_resolved);
        }
        catch(ProtocolError const& err)
        {
            wl_resource_post_error(err.resource(), err.code(), "%s", err.message());
        }
        catch(...)
        {
            internal_error_processing_request(client, "VirtualPointerManagerV1::create_virtual_pointer_with_output()");
        }
    }

    static void resource_destroyed_thunk(wl_resource* resource)
    {
        delete static_cast<VirtualPointerManagerV1*>(wl_resource_get_user_data(resource));
    }

    static void bind_thunk(struct wl_client* client, void* data, uint32_t version, uint32_t id)
    {
        auto me = static_cast<VirtualPointerManagerV1::Global*>(data);
        auto resource = wl_resource_create(
            client,
            &zwlr_virtual_pointer_manager_v1_interface_data,
            std::min((int)version, Thunks::supported_version),
            id);
        if (resource == nullptr)
        {
            wl_client_post_no_memory(client);
            BOOST_THROW_EXCEPTION((std::bad_alloc{}));
        }
        try
        {
            me->bind(resource);
        }
        catch(...)
        {
            internal_error_processing_request(client, "VirtualPointerManagerV1 global bind");
        }
    }

    static struct wl_interface const* create_virtual_pointer_types[];
    static struct wl_interface const* create_virtual_pointer_with_output_types[];
    static struct wl_message const request_messages[];
    static void const* request_vtable[];
};

int const mw::VirtualPointerManagerV1::Thunks::supported_version = 2;

mw::VirtualPointerManagerV1::VirtualPointerManagerV1(struct wl_resource* resource, Version<2>)
    : Resource{resource}
{
    wl_resource_set_implementation(resource, Thunks::request_vtable, this, &Thunks::resource_destroyed_thunk);
}

mw::VirtualPointerManagerV1::~VirtualPointerManagerV1()
{
    wl_resource_set_implementation(resource, nullptr, nullptr, nullptr);
}

bool mw::VirtualPointerManagerV1::is_instance(wl_resource* resource)
{
    return wl_resource_instance_of(resource, &zwlr_virtual_pointer_manager_v1_interface_data, Thunks::request_vtable);
}

mw::VirtualPointerManagerV1::Global::Global(wl_display* display, Version<2>)
    : wayland::Global{
          wl_global_create(
              display,
              &zwlr_virtual_pointer_manager_v1_interface_data,
              Thunks::supported_version,
              this,
              &Thunks::bind_thunk)}
{
}

auto mw::VirtualPointerManagerV1::Global::interface_name() const -> char const*
{
    return VirtualPointerManagerV1::interface_name;
}

struct wl_interface const* mw::VirtualPointerManagerV1::Thunks::create_virtual_pointer_types[] {
    &wl_seat_interface_data,
    &zwlr_virtual_pointer_v1_interface_data};

struct wl_interface const* mw::VirtualPointerManagerV1::Thunks::create_virtual_pointer_with_output_types[] {
    &wl_seat_interface_data,
    &wl_output_interface_data,
    &zwlr_virtual_pointer_v1_interface_data};

struct wl_message const mw::VirtualPointerManagerV1::Thunks::request_messages[] {
    {"create_virtual_pointer", "?on", create_virtual_pointer_types},
    {"destroy", "1", all_null_types},
    {"create_virtual_pointer_with_output", "2?o?on", create_virtual_pointer_with_output_types}};

void const* mw::VirtualPointerManagerV1::Thunks::request_vtable[] {
    (void*)Thunks::create_virtual_pointer_thunk,
    (void*)Thunks::destroy_thunk,
    (void*)Thunks::create_virtual_pointer_with_output_thunk};

mw::VirtualPointerManagerV1* mw::VirtualPointerManagerV1::from(struct wl_resource* resource)
{
    if (resource &&
        wl_resource_instance_of(resource, &zwlr_virtual_pointer_manager_v1_interface_data, VirtualPointerManagerV1::Thunks::request_vtable))
    {
        return static_cast<VirtualPointerManagerV1*>(wl_resource_get_user_data(resource));
    }
    else
    {
        return nullptr;
    }
}

namespace mir
{
namespace wayland
{

struct wl_interface const zwlr_virtual_pointer_v1_interface_data {
    mw::VirtualPointerV1::interface_name,
    mw::VirtualPointerV1::Thunks::supported_version,
    9, mw::VirtualPointerV1::Thunks::request_messages,
    0, nullptr};

struct wl_interface const zwlr_virtual_pointer_manager_v1_interface_data {
    mw::VirtualPointerManagerV1::interface_name,
    mw::VirtualPointerManagerV1::Thunks::supported_version,
    3, mw::VirtualPointerManagerV1::Thunks::request_messages,
    0, nullptr};

}
}
